<template>
    <div class="modal-background" id="outside_modal">
        <div class="study-data-wrapper" id="in_modal">
            <div class="study-data-grid">
                <div class="study-data-box study-data-metadata">
                    <div class="study-data-headline">Metadata</div>
                    <div class="metadata-grid">
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Study Name</div>
                            <div>&nbsp;{{ study_data?.study_name }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Study ID</div>
                            <div>&nbsp;{{ study_data?.study_id }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Visibility</div>
                            <div>&nbsp;{{ study_data?.study_visibility }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Authors</div>
                            <div>&nbsp;{{ study_data?.study_author }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Analytical Method</div>
                            <div>&nbsp;{{ study_data?.study_type }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Biospecimen</div>
                            <div>&nbsp;{{ study_data?.study_specimen }}</div>
                        </div>
                        <div style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div>&nbsp;Date</div>
                            <div>&nbsp;{{ study_data?.study_date }}</div>
                        </div>
                        <div v-for="metadata_key in Object.keys(study_data?.study_metadata as Object)" style="display: grid; grid-template-columns: subgrid; gap: 4px; grid-column: 1/4;">
                            <div v-if="study_data?.study_metadata">&nbsp;{{ study_data.study_metadata[metadata_key].name }}</div>
                            <div v-if="study_data?.study_metadata">&nbsp;{{ study_data.study_metadata[metadata_key].value }}</div>
                        </div>
                    </div>
                </div>
                <div class="study-data-box study-data-phenotypes">
                    <div class="study-data-headline">Phenotypes</div>
                    <span style="font-family: var(--ff-code)" v-for="phenotype in study_data?.study_phenotypes">{{ phenotype }}</span>
                </div>
            </div>
            <div class="buttons" style="margin-top: 0.5rem;">
                <button @click="emit('manage-experimental-data')">Download raw data</button>
                <button @click="emit('close-modal')">Close</button>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useStudyStore } from '@/stores/studies';
import { onMounted, ref, type PropType } from 'vue';
import { type StudyData } from '@/stores/studies';

const studies = useStudyStore();

const emit = defineEmits<{
    'close-modal': [],
    'refresh-studies': [],
    'manage-experimental-data': [],
}>();

const props = defineProps({
    study_data: {} as PropType<StudyData>,
})

/**
 * On mounting, sets values for inside and outside the modal and stores them.
 */
onMounted(() => {
    initialized.value = false;
    if(document.getElementById("in_modal") && document.getElementById("in_modal") != undefined) {
        in_modal.value = document.getElementById("in_modal")
    }
    if(document.getElementById("outside_modal") && document.getElementById("outside_modal") != undefined) {
        outside_modal.value = document.getElementById("outside_modal")
    }
    initialized.value = true;
})

/**
 * Shows the modal if a user clicks inside the modal.
 * Closes it if a user clicks outside the modal.
 */
window.onclick = ((e: MouseEvent): void => {
    if (!initialized) {
        return;
    }
    if ((!in_modal.value || !outside_modal.value) || (e.target == outside_modal.value && e.target != in_modal.value)) {
        emit('close-modal')
    }
});

const in_modal=ref<HTMLElement | null>();
const outside_modal=ref<HTMLElement | null>();
const initialized=ref(false);
const delete_field_open=ref<boolean>(false);
</script>

<style scoped>

.metadata-grid {
    display: grid;
    grid-template-columns: 0.3fr 0.7fr;
    grid-auto-flow: column;
    align-items: center;
    width: 100%;
    row-gap: 4px;
}

.metadata-grid > *:nth-child(2n) {
    background-color: var(--color-bg-alt);
}

.study-data-headline {
    font-weight: bold;
    font-size: var(--fs-large);
    color: var(--color-bg);
    background-color: var(--color-head);
    width: 100%;
    text-align: center;
    grid-column: 1 / 6;
    grid-row: 1;
}
.study-data-wrapper {
    min-width: 75%;
    width: 90%;
    max-width: 100%;
    padding: 1rem;
    background-color: #fff;
    margin: auto;
    box-shadow: var(--sd-larger);
    min-height: 50%;
}

.study-data-metadata {
    grid-column: first-third / main-end;
    grid-row: main-start / main-end;
    background-color: var(--color-bg);
    max-height: 30rem;
}

.study-data-box {
    box-shadow: var(--sd-default);
    border: var(--bd-default);
    display: flex;
    align-items: center;
    flex-direction: column;
    overflow-x: hidden;
    overflow-y: auto;
}

.study-data-phenotypes {
    grid-column: main-start;
    grid-row: main-start / main-end;
    background-color: var(--color-bg);
    max-height: 10rem;
}


.study-data-grid {
    display: grid;
    grid-template-columns: [main-start] 1.25fr [first-third] 1fr [second-third] 1fr [last-third] 1fr [main-end];
    grid-template-rows: [main-start] 1fr [first-third] 1fr [second-third] 1fr [main-end];
    background-color: var(--color-bg);
    min-height: 30rem;
    gap: 12px;
}

</style>